package com.intsig.ccrsdkdemo;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Toast;

import com.intsig.ccrengine.CCREngine.ResultData;
import com.intsig.ccrengine.CommonUtil;
import com.intsig.ccrengine.ISCardScanActivity;

public class MainActivity extends Activity implements OnClickListener {
	private static final String TAG = "MainActivity";
	/*
	 * @CN:替换您申请的合合信息授权提供的APP_KEY; 2017 0331
	 * 
	 * @EN:replace your appkey from the intsig company
	 */
	private static final String APP_KEY = "8573d6ba23cff6632f582c2c20-vagfvt";
	private static final int REQ_CODE_CAPTURE = 100;

	public static boolean boolCheckAppKey = true;
	public static final String BANKCARD_TRIM_DIR = Environment.getExternalStorageDirectory()+"/trimedcard.jpg";
	public static final String BANKCARD_ORG_DIR = Environment.getExternalStorageDirectory()+"/origianlcard.jpg";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		if (!boolCheckAppKey) {
			useCamare();
		} else {
			setContentView(R.layout.main_activity);
			findViewById(R.id.btn_use_camare_module).setOnClickListener(this);
			findViewById(R.id.btn_not_use_camare_module).setOnClickListener(
					this);

		}
	}

	public void useCamare() {
		/*
		 * @CN: 通过Intent调用SDK中的相机拍摄模块ISCardScanActivity进行识别
		 * 
		 * @EN: use ISCardScanActivity to recognize. the ISCardScanActivity is
		 * the user define camera of intsig's SDK
		 */
		Intent intent = new Intent(this, ISCardScanActivity.class); 
		 intent.putExtra(ISCardScanActivity.EXTRA_KEY_SHOW_CLOSE,
				 true);
		 intent.putExtra(ISCardScanActivity.EXTRA_KEY_TIPS_FONT_SIZE,
				 23);
		 
		 intent.putExtra(ISCardScanActivity.EXTRA_KEY_TIPS_FONT_COLOR,
				 Color.WHITE);
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_ORIENTATION,
				ISCardScanActivity.ORIENTATION_HORIZONTAL);

		/*
		 * @CN: 指定SDK相机模块ISCardScanActivity四边框角线条,检测到银行卡图片后的颜色
		 * 
		 * @EN: set the Quadrilateral angle color when the camera is checking
		 * the picture.
		 */
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_COLOR_MATCH,0xff2A7DF3 );
		/*
		 * @CN: 指定SDK相机模块ISCardScanActivity四边框角线条颜色，正常显示颜色
		 * 
		 * @EN: set the Quadrilateral angle default color
		 */
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_COLOR_NORMAL, 0xff01d2ff);
		/*
		 * @CN: 指定SDK相机模块ISCardScanActivity提示字符串
		 * 
		 * @EN: set the title of the user define camera
		 */
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_TIPS, getResources()
				.getString(R.string.cui_preview_commment_title));
		/*
		 * @CN: 合合信息授权提供的APP_KEY
		 * 
		 * @EN: set the appkey of intsig
		 */
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_APP_KEY, APP_KEY);
		/*
		 * @CN: 指定SDK相机模块是否返回银行卡卡号截图
		 * 
		 * @EN: Specifies whether the SDK camera module returns the bank card
		 * number. set true or false
		 */
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_GET_NUMBER_IMG, true);
		/*
		 * @CN: 指定SDK相机模块银行卡切边图路径
		 * 
		 * @EN:Specify the SDK camera module bank khache edge graph path
		 */
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_GET_TRIMED_IMG,
				BANKCARD_TRIM_DIR);
		/*
		 * @CN: 指定SDK相机模块银行卡原图路径
		 * 
		 * @EN:Specify the SDK camera module bank card original path
		 */
		intent.putExtra(ISCardScanActivity.EXTRA_KEY_GET_ORIGINAL_IMG,
				BANKCARD_ORG_DIR);

		

		startActivityForResult(intent, REQ_CODE_CAPTURE);

	}

	@Override
	public void onClick(View view) {
		int id = view.getId();

		if (id == R.id.btn_use_camare_module) {
			useCamare();
		} else {
			/*
			 * @CN: 在PreviewActivity中自定义相机拍摄模块，然后直接调用SDK中的银行卡预览方法进行识别..
			 * 在PreviewActivity中可以直接获得SDK返回的ResultData识别结果
			 * 
			 * @EN:In the PreviewActivity custom camera shooting module, and
			 * then call the SDK bank card preview method for identification in
			 * PreviewActivity can be obtained directly in the SDK ResultData
			 * recognition results
			 */

			Intent intent = new Intent(this, PreviewActivity.class);
			/*
			 * @CN: 合合信息授权提供的APP_KEY
			 * 
			 * @EN: APP_KEY provided by the intsig
			 */
			intent.putExtra(PreviewActivity.EXTRA_KEY_APP_KEY, APP_KEY);
			/*
			 * @CN: 指定SDK相机模块是否返回银行卡卡号截图
			 * 
			 * @EN: Specifies whether the SDK camera module returns the bank
			 * card number
			 */
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_GET_NUMBER_IMG, true);
			/*
			 * @CN: 指定SDK相机模块银行卡切边图路径
			 * 
			 * @EN:Specify the SDK camera module bank khache edge graph path
			 */
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_GET_TRIMED_IMG,
					BANKCARD_TRIM_DIR);
			/*
			 * @CN: 指定SDK相机模块银行卡原图路径
			 * 
			 * @EN:Specify the SDK camera module bank card original path
			 */
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_GET_ORIGINAL_IMG,
					BANKCARD_ORG_DIR);
			startActivityForResult(intent, REQ_CODE_CAPTURE);
		}
	}

	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		if (resultCode == RESULT_OK && requestCode == REQ_CODE_CAPTURE) {
			/*
			 * @CN: 获取银行卡识别ResultData识别结果
			 * 
			 * @EN:Obtain bank card recognition ResultData identification
			 * results
			 */
			ResultData result = (ResultData) data
					.getSerializableExtra(ISCardScanActivity.EXTRA_KEY_RESULT);
			
			/*
			 * @CN: 在RecogResultActivity中显示银行卡识别结果
			 * 
			 * @EN: Display bank card recognition results in RecogResultActivity
			 */
			Intent intent = new Intent(this, RecogResultActivity.class);
			Bitmap bmp = (Bitmap) data
					.getParcelableExtra(ISCardScanActivity.EXTRA_KEY_GET_NUMBER_IMG);
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_GET_NUMBER_IMG, bmp);
			intent.putExtra(ISCardScanActivity.EXTRA_KEY_RESULT, result);
			startActivity(intent);

//			this.overridePendingTransition(R.anim.cui_fade_in, 0);

			if (!boolCheckAppKey) {
				finish();
			}

		} else if (resultCode == RESULT_CANCELED
				&& requestCode == REQ_CODE_CAPTURE) {

			Log.d(TAG, "识别失败或取消，请参考返回错误码说明");
			if (data != null) {
				/*
				 * 101 包名错误, 授权APP_KEY与绑定的APP包名不匹配； 102 appKey错误，传递的APP_KEY填写错误；
				 * 103 超过时间限制，授权的APP_KEY超出使用时间限制； 104
				 * 达到设备上限，授权的APP_KEY使用设备数量达到限制； 201 签名错误，授权的APP_KEY与绑定的APP签名不匹配；
				 * 202 其他错误，其他未知错误，比如初始化有问题； 203 服务器错误，第一次联网验证时，因服务器问题，没有验证通过；
				 * 204 网络错误，第一次联网验证时，没有网络连接，导致没有验证通过； 205
				 * 包名/签名错误，授权的APP_KEY与绑定的APP包名和签名都不匹配；
				 * 
				 * EN: please read the document
				 */
				int error_code = 0;
				error_code=	 data.getIntExtra(ISCardScanActivity.EXTRA_KEY_RESULT_ERROR_CODE,
									 0);
				
				
				Toast.makeText(
						this,
						"Error:"
								+ error_code
								+ "\nMsg:"
								+ CommonUtil.getPkgSigKeyLog(MainActivity.this,
										APP_KEY), Toast.LENGTH_LONG).show();
				
				Toast.makeText(
						this,
						"初始化过程中如果报错，报错日志会自动存储在/sdcard/IntsigLog/IntsigLog.txt文件中，请前往拷贝发送给合合信息技术支持分析解决问题，谢谢"
								, Toast.LENGTH_LONG).show();
			}

			if (!boolCheckAppKey) {
				finish();
			}
		}
	}
}
