/**
 * Project Name:IDCardScanCaller
 * File Name:RecogActivity.java
 * Package Name:com.intsig.idcardscancaller
 * Date:2016年3月15日下午3:58:29
 * Copyright (c) 2016, 上海合合信息 All Rights Reserved.
 *
 */

package com.intsig.ccrsdkdemo;

import java.util.ArrayList;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.os.Bundle;
import android.support.v4.view.ViewPager;
import android.support.v4.view.ViewPager.OnPageChangeListener;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;
import android.widget.LinearLayout;
import android.widget.PopupWindow;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RadioGroup.OnCheckedChangeListener;
import android.widget.RelativeLayout;
import android.widget.TextView;

import com.intsig.ccrengine.CCREngine;
import com.intsig.ccrengine.CCREngine.ResultData;
import com.intsig.ccrengine.ISCardScanActivity;
import com.intsig.commonui.MyZoomImageView;
import com.intsig.commonui.ViewPagerAdapter;

public class RecogResultActivity extends Activity {

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		setContentView(R.layout.ac_recog);
		Intent intent = getIntent();
		String image_path = MainActivity.BANKCARD_ORG_DIR;

		

		// TextView use_time_all_id = ((TextView)
		// findViewById(R.id.use_time_all_id));
		// use_time_all_id.setText(regtimeall);

		ResultData result = (ResultData) intent
				.getSerializableExtra(ISCardScanActivity.EXTRA_KEY_RESULT);
		 String regtimeall = result.getRegtimeString();
		
		// 图片角度,如果有图片的话
		if (TextUtils.isEmpty(regtimeall)) {
			findViewById(R.id.use_time_row_id)
					.setVisibility(View.GONE);
		} else {

			((TextView) findViewById(R.id.use_time_id)).setText(regtimeall
					+ "ms");
		}

		initPagerView(image_path, MainActivity.BANKCARD_TRIM_DIR);

		// 卡号 CardNumber
		String number = result.getCardNumber();
		tv_label_id = ((TextView) findViewById(R.id.label_card_id));
		tv_label_id.setText(number);
		if (number != null)
			number = number.substring(0, 13);
		//		Toast.makeText(
//				this,
//				"GetInstitution(" + number + ")"
//						+ (insData != null ? Arrays.toString(insData) : "null"),
//				Toast.LENGTH_SHORT).show();
		// 持卡人 CardHolderName
		if (TextUtils.isEmpty(result.getCardHolderName())) {

			 findViewById(R.id.label_holder_name_row)
					.setVisibility(View.GONE);
		} else {
			((TextView) findViewById(R.id.label_holder_name)).setText(result
					.getCardHolderName());
		}
		// 过期日期 CardValidThru
		
		if (TextUtils.isEmpty(result.getCardValidThru())) {
			// gone
			findViewById(R.id.tableRow_valid_thru).setVisibility(View.GONE);
		} else {
			findViewById(R.id.tableRow_valid_thru).setVisibility(View.VISIBLE);
			((TextView) findViewById(R.id.label_valid_thru)).setText(result
					.getCardValidThru());
		}

		// 发卡机构 CardInsName
		String tmp = result.getCardInsName();
		if (tmp == null) {// 未找到
			findViewById(R.id.tableRow_bank_name).setVisibility(View.GONE);
		} else {
			findViewById(R.id.tableRow_bank_name).setVisibility(View.VISIBLE);
			if (!TextUtils.isEmpty(result.getCardInsId()))
				tmp += "(" + result.getCardInsId() + ")";
			((TextView) findViewById(R.id.label_institution)).setText(tmp);
		}

		// 卡片类型 BankCardType
//		((TextView) findViewById(R.id.label_card_type))
//				.setText());
		
		Log.e("type:", result.getBankCardType()+"");

		((TextView) findViewById(R.id.label_card_type))
		.setText(getString(getBankCardType(result.getBankCardType())));
		// 信用卡类型 CreditCardType
		tmp = "";
		if (CCREngine.CCR_TYPE_CREDIT_CARD == result.getBankCardType()
				|| CCREngine.CCR_TYPE_QUASI_CREDIT_CARD == result
						.getBankCardType()) {
			tmp = getCreditCardType(result.getCreditCardType());
			findViewById(R.id.tableRow_cc_type).setVisibility(View.VISIBLE);
			((TextView) findViewById(R.id.label_credit_card_type)).setText(tmp);
			ImageView icon_credit_card_type = ((ImageView) findViewById(R.id.icon_credit_card_type));

			icon_credit_card_type.setImageResource(getCreditCardIcon(result
					.getCreditCardType()));
		} else {
			findViewById(R.id.tableRow_cc_type).setVisibility(View.GONE);
		}
		// 获取银行卡卡号截图
		shotPathStringBmp = (Bitmap) intent
				.getParcelableExtra(ISCardScanActivity.EXTRA_KEY_GET_NUMBER_IMG);

		((ImageView) findViewById(R.id.tv_label_img_id))
				.setOnClickListener(onClickListenerTrim);

	}

	public void onClick(View view) {
		if (!MainActivity.boolCheckAppKey) {

			Intent intent = new Intent(this, MainActivity.class);

			startActivity(intent);
			finish();
		} else {
			finish();
		}

	}

	// ***********************************UI***************************************/
	ViewPager vp;
	RadioGroup group;
	ViewPagerAdapter vpAdapter;
	int currentItem;
	Bitmap shotPathStringBmp;

	@SuppressWarnings("deprecation")
	public void initPagerView(String path1, String path2) {

		vp = (ViewPager) findViewById(R.id.viewpager);
		group = (RadioGroup) findViewById(R.id.RadioGroup);
		group.setOnCheckedChangeListener(listener);
		 views = new ArrayList<View>();

		LinearLayout.LayoutParams mParams = new LinearLayout.LayoutParams(
				LinearLayout.LayoutParams.WRAP_CONTENT,
				LinearLayout.LayoutParams.WRAP_CONTENT);
		mParams.setMargins(20, 20, 20, 20);

		MyZoomImageView iv2 = new MyZoomImageView(this);
		iv2.setLayoutParams(mParams);

		if (!TextUtils.isEmpty(path2)) {
			pathList.add(path2);
			Bitmap bmp = loadBitmap(path2);
			if (bmp != null) {
				iv2.setImageBitmap(bmp);
			}
		}
		iv2.setScaleType(ScaleType.FIT_CENTER);
		iv2.initUI();
		views.add(iv2);
		MyZoomImageView iv = new MyZoomImageView(this);
		iv.setLayoutParams(mParams);

		if (!TextUtils.isEmpty(path1)) {
			pathList.add(path1);
			Bitmap bmp = loadBitmap(path1);
			if (bmp != null) {
				iv.setImageBitmap(bmp);
			}
		}

		iv.setScaleType(ScaleType.FIT_CENTER);
		iv.initUI();
		views.add(iv);
		vpAdapter = new ViewPagerAdapter(views);
		vp.setAdapter(vpAdapter);
		vp.setOnPageChangeListener(new OnPageChangeListener() {

			@Override
			public void onPageSelected(final int position) {
				final RadioButton radioButton = (RadioButton) group
						.getChildAt(position);
				radioButton.setChecked(true);
				currentItem = position;
			}

			@Override
			public void onPageScrolled(final int arg0, final float arg1, final int arg2) {

			}

			@Override
			public void onPageScrollStateChanged(final int arg0) {

			}
		});
		findViewById(R.id.rotation_title_id).setOnClickListener(
				new OnClickListener() {

					@Override
					public void onClick(View arg0) {
						// TODO Auto-generated method stub
						rotation[currentItem] = rotation[currentItem] + 90;
						if (rotation[currentItem] < 360) {
							setRoateImageview(rotation[currentItem]);
						} else {
							rotation[currentItem] = 0;
							setRoateImageview(rotation[currentItem]);
						}
					}
				});
	}
	int[] rotation = new int[2];
	List<View> views;
	List<String> pathList=new ArrayList<String>();
	public void setRoateImageview(int progress) {

		MyZoomImageView imageView = (MyZoomImageView) views.get(currentItem);
		// imageView.setDrawingCacheEnabled(true);
		Bitmap bitmap = loadBitmap(pathList.get(currentItem));
		// 设置旋转角度
		Matrix matrix = new Matrix();
		matrix.setRotate(progress);
		// 重新绘制Bitmap
		bitmap = Bitmap.createBitmap(bitmap, 0, 0, bitmap.getWidth(),
				bitmap.getHeight(), matrix, true);
		imageView.setImageBitmap(bitmap);
		// imageView.setDrawingCacheEnabled(false);
		imageView.setScaleType(ScaleType.FIT_CENTER);
		imageView.initUI();
	}

	OnCheckedChangeListener listener = new OnCheckedChangeListener() {

		@Override
		public void onCheckedChanged(RadioGroup group, int checkId) {
			switch (checkId) {
			case R.id.radio1:
				vp.setCurrentItem(0);
				currentItem = 0;
				break;
			case R.id.radio2:
				vp.setCurrentItem(1);
				currentItem = 1;
				break;

			default:
				break;
			}
		}
	};

	public void setBackgroundAlpha(float bgAlpha) {
		WindowManager.LayoutParams lp = getWindow().getAttributes();
		if (bgAlpha == 1) {
			getWindow().clearFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);// 不移除该Flag的话,在有视频的页面上的视频会出现黑屏的bug
		} else {
			getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);// 此行代码主要是解决在华为手机上半透明效果无效的bug
		}
		lp.alpha = bgAlpha;

		RecogResultActivity.this.getWindow().setAttributes(lp);
	}

	String shotPathString;
	TextView tv_label_id;
	OnClickListener onClickListenerTrim = new OnClickListener() {

		@Override
		public void onClick(View arg0) {
			// TODO Auto-generated method stub
			RelativeLayout layout = (RelativeLayout) LayoutInflater.from(
					RecogResultActivity.this).inflate(
					R.layout.cui_view_loadingdialog, null);
			final PopupWindow popupWindow = new PopupWindow(layout,
					ViewGroup.LayoutParams.WRAP_CONTENT,
					ViewGroup.LayoutParams.WRAP_CONTENT, true);

			ImageView loading_image = (ImageView) layout
					.findViewById(R.id.loading_image);
			Bitmap bmp = shotPathStringBmp;
			if (bmp != null) {
				loading_image.setImageBitmap(bmp);

			}
			setBackgroundAlpha(0.8f);
			popupWindow.showAsDropDown(tv_label_id);

			popupWindow.setOutsideTouchable(true);
			popupWindow.setTouchable(true);
			popupWindow.setFocusable(true);
			layout.setOnClickListener(new OnClickListener() {

				@Override
				public void onClick(View arg0) {
					// TODO Auto-generated method stub
					Log.e("setBackgroundAlpha", "1f");
					setBackgroundAlpha(1f);

					popupWindow.dismiss();
				}
			});

		}
	};

	private int getBankCardType(int type) {
		switch (type) {
		case CCREngine.CCR_TYPE_CREDIT_CARD:
			return R.string.credit_card;
		case CCREngine.CCR_TYPE_DEBIT_CARD:
			return R.string.debit_card;
		case CCREngine.CCR_TYPE_QUASI_CREDIT_CARD:
			return R.string.quasi_credit_card;

		default:
			return R.string.unknow_card;
		}
	}

	private int getCreditCardIcon(int type) {
		switch (type) {
		case CCREngine.CCR_CARD_TYPE_VISA:// 4; // Visa
			return R.drawable.ic_visa;
		case CCREngine.CCR_CARD_TYPE_MASTER:// 5; // MasterCard
			return R.drawable.ic_mastercard;
		case CCREngine.CCR_CARD_TYPE_MAESTRO:// 6; // Maestro
			// return R.drawable.
		case CCREngine.CCR_CARD_TYPE_AMEX:// 7; // American Express
			return R.drawable.ic_amexpress;
		case CCREngine.CCR_CARD_TYPE_DINERS:// 8; // Diners Club
			return -1;
		case CCREngine.CCR_CARD_TYPE_DISCOVER:// 9; // Discover
			return -1;
		case CCREngine.CCR_CARD_TYPE_JCB:// 10; // JCB
			return R.drawable.ic_jcb;
		case CCREngine.CCR_CARD_TYPE_CHINA_UNIONPAY:// 11; // 银联
			return R.drawable.ic_unionpay;
		default:
			return -1;
		}
	}

	private String getCreditCardType(int type) {
		switch (type) {
		case CCREngine.CCR_CARD_TYPE_VISA:// 4; // Visa
			return "Visa";
		case CCREngine.CCR_CARD_TYPE_MASTER:// 5; // MasterCard
			return "MasterCard";
		case CCREngine.CCR_CARD_TYPE_MAESTRO:// 6; // Maestro
			return "Maestro";
		case CCREngine.CCR_CARD_TYPE_AMEX:// 7; // American Express
			return "American Express";
		case CCREngine.CCR_CARD_TYPE_DINERS:// 8; // Diners Club
			return "Diners Club";
		case CCREngine.CCR_CARD_TYPE_DISCOVER:// 9; // Discover
			return "Discover";
		case CCREngine.CCR_CARD_TYPE_JCB:// 10; // JCB
			return "JCB";
		case CCREngine.CCR_CARD_TYPE_CHINA_UNIONPAY:// 11; // 银联
			return "银联";
		default:
			return " ";
		}
	}

	public static Bitmap loadBitmap(String pathName) {
		Bitmap b = null;
		try {
			BitmapFactory.Options opts = new BitmapFactory.Options();
			opts.inPreferredConfig = Bitmap.Config.RGB_565;
			b = BitmapFactory.decodeFile(pathName, opts);
		} catch (Exception e) {
			e.printStackTrace();
			b = null;
		} catch (OutOfMemoryError e) {
			e.printStackTrace();
			b = null;
		}
		return b;
	}
}
